﻿/*******************************************************************************
File        : PersonSELECT.cs
Description : 
--------------------------------------------------------------------------------
Functions:
--------------------------------------------------------------------------------
History:
2011/05/13 WLM Created
*******************************************************************************/
using System;
using System.Windows.Forms;
using Wiker.WIDatabase;
using System.Text;

namespace WIDatabaseSample
{
/*******************************************************************************
Class        : MainForm
Description  : 
--------------------------------------------------------------------------------
History:
2011/04/12 WLM Created
*******************************************************************************/
public partial class MainForm
{
/*******************************************************************************
Function    : NewPersonSELECT()
Description : 
Parameters  : stPerson person - 
Returns     : bool
--------------------------------------------------------------------------------
History:
2011/05/13 WLM Created
*******************************************************************************/
bool NewPersonSELECT(stPerson person)
{
WIDBUtil dbUtil;
string Str;

/* Create Connection To Database */
dbUtil = new WIDBUtil(GetDBInfo());

if (dbUtil.LastError != eDBErrorCodes.None)
   {
   Str = string.Format("Failed to open database\n{0}\nLastError = {1}", GetDBName(dbUtil.DatabaseType),
      dbUtil.LastError.ToString());
   MessageBox.Show(Str);
   return(false);
   }

if (!dbUtil.Open()) /* Open Database */
   {
   Str = string.Format("Failed to open database\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/*----------------------------------------------------------------------------*/

/* Save Person Address */
if (!SaveAddressSELECT(dbUtil, person.Address))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Save Address\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/* Save Person Image If Exists */
if (person.PhotoImage != null)
   {
   if (!SaveImageSELECT(dbUtil, person.PhotoImage, out person.PhotoID))
      {
      dbUtil.Close();
      Str = string.Format("Failed to Save Image\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
         dbUtil.LastErrorMessage);
      MessageBox.Show(Str);
      return(false);
      }
   }

/* Save Person Infomation */
if (!SavePersonSELECT(dbUtil, person))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Save Person\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/*----------------------------------------------------------------------------*/

/* Save Person Home Phone */
if (!SavePhoneSELECT(dbUtil, 0, person.PersonID, ePhoneType.Home, person.PhoneHome))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Save Home Phone\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/* Save Person Work Phone */
if (!SavePhoneSELECT(dbUtil, 0, person.PersonID, ePhoneType.Work, person.PhoneWork))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Save Work Phone\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/* Save Person Cell Phone */
if (!SavePhoneSELECT(dbUtil, 0, person.PersonID, ePhoneType.Cell, person.PhoneCell))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Save Cell Phone\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/* Save Person Fax Phone */
if (!SavePhoneSELECT(dbUtil, 0, person.PersonID, ePhoneType.Fax, person.PhoneFax))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Save Fax Phone\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/* Save Person Other Phone */
if (!SavePhoneSELECT(dbUtil, 0, person.PersonID, ePhoneType.Other, person.PhoneOther))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Save Other Phone\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }


dbUtil.Close();

return(true);
}
/*******************************************************************************
Function    : SearchPersonSELECT()
Description : 
Parameters  : stPerson person - 
Returns     : bool
--------------------------------------------------------------------------------
History:
2011/05/13 WLM Created
*******************************************************************************/
bool SearchPersonSELECT(stPerson person)
{
WIDBUtil dbUtil;
StringBuilder StrB;
string Str;

dbUtil = null;

try
{
/* Create Connection To Database */
dbUtil = new WIDBUtil(GetDBInfo());

if (dbUtil.LastError != eDBErrorCodes.None)
   {
   Str = string.Format("Failed to open database\n{0}\nLastError = {1}", GetDBName(dbUtil.DatabaseType),
      dbUtil.LastError.ToString());
   MessageBox.Show(Str);
   return(false);
   }

StrB = new StringBuilder(); /* Build Select Request */


StrB.Append("SELECT tblPerson.PersonID, tblPerson.AddressID, tblPerson.CompanyID, ");
StrB.Append("Name, PhotoID, Active, Address1, Address2, City, State, ZipCode, ImageData, ");
StrB.Append("P1.Number AS PhoneHome, P2.Number AS PhoneWork, ");
StrB.Append("P3.Number AS PhoneCell, P4.Number AS PhoneFax, ");
StrB.Append("P5.Number AS PhoneOther ");

StrB.Append("FROM tblPerson ");
StrB.Append("LEFT JOIN tblAddress ON (tblPerson.AddressID = tblAddress.AddressID) ");
StrB.Append("LEFT JOIN tblImage ON (PhotoID = tblImage.ImageID) ");
StrB.AppendFormat("LEFT JOIN tblPhone P1 ON (P1.PersonID = tblPerson.PersonID AND P1.Type = {0}) ", (int)ePhoneType.Home);
StrB.AppendFormat("LEFT JOIN tblPhone P2 ON (P2.PersonID = tblPerson.PersonID AND P2.Type = {0}) ", (int)ePhoneType.Work);
StrB.AppendFormat("LEFT JOIN tblPhone P3 ON (P3.PersonID = tblPerson.PersonID AND P3.Type = {0}) ", (int)ePhoneType.Cell);
StrB.AppendFormat("LEFT JOIN tblPhone P4 ON (P4.PersonID = tblPerson.PersonID AND P4.Type = {0}) ", (int)ePhoneType.Fax);
StrB.AppendFormat("LEFT JOIN tblPhone P5 ON (P5.PersonID = tblPerson.PersonID AND P5.Type = {0}) ", (int)ePhoneType.Other);
StrB.AppendFormat("WHERE tblPerson.PersonID = {0} ", person.PersonID);

dbUtil.CommandText = StrB.ToString();

if (!dbUtil.Open()) /* Open Database */
   {
   Str = string.Format("Failed to open database\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

if (!dbUtil.ReadRow())
   {
   Str = string.Format("Failed to ReadRow\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/*----------------------------------------------------------------------------*/
/*
0 PersonID
1 AddressID
2 CompanyID
3 Name
4 PhotoID
5 Active
6 Address1
7 Address2
8 City
9 State
10 ZipCode
11 ImageData
12 PhoneHome
13 PhoneWork
14 PhoneCell
15 PhoneFax
16 PhoneOther
*/

person.PersonID = dbUtil.ReadInt(0);
person.Address.AddressID = dbUtil.ReadInt(1);
person.Company.CompanyID = dbUtil.ReadInt(2);
person.Name = dbUtil.ReadString(3);
person.PhotoID = dbUtil.ReadInt(4);
person.Active = dbUtil.ReadBool(5);

person.Address.Address1 = dbUtil.ReadString(6);
person.Address.Address2 = dbUtil.ReadString(7);
person.Address.City = dbUtil.ReadString(8);
person.Address.State = dbUtil.ReadString(9);
person.Address.ZipCode = dbUtil.ReadString(10);

person.PhotoImage = dbUtil.ReadImage(11);

person.PhoneHome = dbUtil.ReadString(12);
person.PhoneWork = dbUtil.ReadString(13);
person.PhoneCell = dbUtil.ReadString(14);
person.PhoneFax = dbUtil.ReadString(15);
person.PhoneOther = dbUtil.ReadString(16);

dbUtil.Close();

return(true);
}

catch (Exception ex)
   {
   if (dbUtil != null)
      dbUtil.Close();

   Str = string.Format("SearchPersonSELECT() Exception\n{0}", ex.Message);
   MessageBox.Show(Str);
   return(false);
   }
}
/*******************************************************************************
Function    : UpdatePersonSELECT()
Description : 
Parameters  : stPerson person - 
Returns     : bool
--------------------------------------------------------------------------------
History:
2011/05/13 WLM Created
*******************************************************************************/
bool UpdatePersonSELECT(stPerson person)
{
WIDBUtil dbUtil;
string Str;

/* Create Connection To Database */
dbUtil = new WIDBUtil(GetDBInfo());

if (dbUtil.LastError != eDBErrorCodes.None)
   {
   Str = string.Format("Failed to open database\n{0}\nLastError = {1}", GetDBName(dbUtil.DatabaseType),
      dbUtil.LastError.ToString());
   MessageBox.Show(Str);
   return(false);
   }

if (!dbUtil.Open()) /* Open Database */
   {
   Str = string.Format("Failed to open database\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/*----------------------------------------------------------------------------*/

/* Update Person Address */
if (!UpdateAddressSELECT(dbUtil, person.Address))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Update Address\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/*----------------------------------------------------------------------------*/

/* Update Company Logo If Exists */
if (person.PhotoImage != null)
   {
   if (person.PhotoID > 0) /* Update Existing Image */
      {
      if (!UpdateImageSELECT(dbUtil, person.PhotoImage, person.PhotoID))
         {
         dbUtil.Close();
         Str = string.Format("Failed to Update Image\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
            dbUtil.LastErrorMessage);
         MessageBox.Show(Str);
         return(false);
         }
      }

   else
      {  /* New Image */
      if (!SaveImageSELECT(dbUtil, person.PhotoImage, out person.PhotoID))
         {
         dbUtil.Close();
         Str = string.Format("Failed to Save Image\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
            dbUtil.LastErrorMessage);
         MessageBox.Show(Str);
         return(false);
         }
      }
   }

else
if(person.PhotoID > 0) /* Delete Existing Image */
   {
   if (!DeleteImageSELECT(dbUtil, person.PhotoID))
      {
      dbUtil.Close();
      Str = string.Format("Failed to Delete Image\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
         dbUtil.LastErrorMessage);
      MessageBox.Show(Str);
      return(false);
      }
   }

/*----------------------------------------------------------------------------*/

/* Update Company Infomation */
if (!UpdatePersonSELECT(dbUtil, person))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Update Person\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/*----------------------------------------------------------------------------*/

/* Update Home Phone */
if (!UpdatePhoneSELECT(dbUtil, 0, person.PersonID, ePhoneType.Home, person.PhoneHome))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Update Home Phone\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/* Update Work Phone */
if (!UpdatePhoneSELECT(dbUtil, 0, person.PersonID, ePhoneType.Work, person.PhoneWork))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Update Work Phone\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/* Update Cell Phone */
if (!UpdatePhoneSELECT(dbUtil, 0, person.PersonID, ePhoneType.Cell, person.PhoneCell))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Update Cell Phone\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/* Update Fax Phone */
if (!UpdatePhoneSELECT(dbUtil, 0, person.PersonID, ePhoneType.Fax, person.PhoneFax))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Update Fax Phone\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/* Update Other Phone */
if (!UpdatePhoneSELECT(dbUtil, 0, person.PersonID, ePhoneType.Other, person.PhoneOther))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Update Other Phone\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

dbUtil.Close();

return(true);
}
/*******************************************************************************
Function    : UpdatePersonSELECT()
Description : 
Parameters  : WIDBUtil dbUtil - 
            : stPerson person - 
Returns     : bool
--------------------------------------------------------------------------------
History:
2011/05/13 WLM Created
*******************************************************************************/
bool UpdatePersonSELECT(WIDBUtil dbUtil, stPerson person)
{
StringBuilder StrB;
int Active;
string Str;
bool Result;

if (person == null || person.PersonID < 1)
   return(false);

if (person.Active)
   Active = 1;

else
   Active = 0;

StrB = new StringBuilder();
StrB.Append("UPDATE tblPerson SET ");
StrB.AppendFormat("Name = '{0}', ", person.Name);
StrB.AppendFormat("Active = '{0}', ", Active);
StrB.AppendFormat("AddressID = '{0}', ", person.Address.AddressID);
StrB.AppendFormat("CompanyID = '{0}', ", person.Company.CompanyID);
StrB.AppendFormat("PhotoID = '{0}' ", person.PhotoID);
StrB.AppendFormat("WHERE PersonID = {0} ", person.PersonID);

try
{
Result = dbUtil.ExecuteTransaction(StrB.ToString());

return(Result);
}

catch (Exception ex)
   {
   Str = string.Format("Failed to Update Person\n{0}", ex.Message);
   MessageBox.Show(Str);
   return(false);
   }
}
/*******************************************************************************
Function    : DeletePersonSELECT()
Description : 
Parameters  : stPerson person - 
Returns     : bool
--------------------------------------------------------------------------------
History:
2011/05/13 WLM Created
*******************************************************************************/
bool DeletePersonSELECT(stPerson person)
{
WIDBUtil dbUtil;
string Str;

/* Create Connection To Database */
dbUtil = new WIDBUtil(GetDBInfo());

if (dbUtil.LastError != eDBErrorCodes.None)
   {
   Str = string.Format("Failed to open database\n{0}\nLastError = {1}", GetDBName(dbUtil.DatabaseType),
      dbUtil.LastError.ToString());
   MessageBox.Show(Str);
   return(false);
   }

if (!dbUtil.Open()) /* Open Database */
   {
   Str = string.Format("Failed to open database\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/*----------------------------------------------------------------------------*/

if (person.Address.AddressID > 0)
   {
   if (!DeleteAddressSELECT(dbUtil, person.Address))
      {
      dbUtil.Close();
      Str = string.Format("Failed to Delete Address\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
         dbUtil.LastErrorMessage);
      MessageBox.Show(Str);
      return(false);
      }
   }

if (person.PhotoID > 0)
   {
   if (!DeleteImageSELECT(dbUtil, person.PhotoID))
      {
      dbUtil.Close();
      Str = string.Format("Failed to Delete Image\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
         dbUtil.LastErrorMessage);
      MessageBox.Show(Str);
      return(false);
      }
   }

/*----------------------------------------------------------------------------*/

/* Delete Home Phone */
if (!DeletePhoneSELECT(dbUtil, 0, person.PersonID, ePhoneType.Home))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Delete Home Phone\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/* Delete Work Phone */
if (!DeletePhoneSELECT(dbUtil, 0, person.PersonID, ePhoneType.Work))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Delete Work Phone\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/* Delete Cell Phone */
if (!DeletePhoneSELECT(dbUtil, 0, person.PersonID, ePhoneType.Cell))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Delete Cell Phone\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/* Delete Fax Phone */
if (!DeletePhoneSELECT(dbUtil, 0, person.PersonID, ePhoneType.Fax))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Delete Fax Phone\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/* Delete Other Phone */
if (!DeletePhoneSELECT(dbUtil, 0, person.PersonID, ePhoneType.Other))
   {
   dbUtil.Close();
   Str = string.Format("Failed to Delete Other Phone\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/*----------------------------------------------------------------------------*/

if (person.PersonID > 0)
   {
   if (!DeletePersonSELECT(dbUtil, person.PersonID))
      {
      dbUtil.Close();
      Str = string.Format("Failed to Delete Person\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
         dbUtil.LastErrorMessage);
      MessageBox.Show(Str);
      return(false);
      }
   }

dbUtil.Close();

return(true);
}
/*******************************************************************************
Function    : DeletePersonSELECT()
Description : 
Parameters  : WIDBUtil dbUtil - 
            : int personID - 
Returns     : bool
--------------------------------------------------------------------------------
History:
2011/05/13 WLM Created
*******************************************************************************/
bool DeletePersonSELECT(WIDBUtil dbUtil, int personID)
{
StringBuilder StrB;
string Str;
bool Result;

if (personID < 1)
   return(false);


StrB = new StringBuilder();
StrB.Append("DELETE FROM tblPerson ");
StrB.AppendFormat("WHERE PersonID = {0} ", personID);

try
{
Result = dbUtil.ExecuteTransaction(StrB.ToString());

return(Result);
}

catch (Exception ex)
   {
   Str = string.Format("Failed to Delete Person\n{0}", ex.Message);
   MessageBox.Show(Str);
   return(false);
   }
}
/*******************************************************************************
Function    : LoadPersonNamesSELECT()
Description : 
Parameters  : None
Returns     : bool
--------------------------------------------------------------------------------
History:
2011/05/13 WLM Created
*******************************************************************************/
bool LoadPersonNamesSELECT()
{
WIDBUtil dbUtil;
string Str;
StringBuilder StrB;
stPerson Person;

dbUtil = null;

try
{
/* Create Connection To Database */
dbUtil = new WIDBUtil(GetDBInfo());

if (dbUtil.LastError != eDBErrorCodes.None)
   {
   Str = string.Format("Failed to open database\n{0}\nLastError = {1}", GetDBName(dbUtil.DatabaseType),
      dbUtil.LastError.ToString());
   MessageBox.Show(Str);
   return(false);
   }

/*----------------------------------------------------------------------------*/

StrB = new StringBuilder(); /* Build Select Request */
StrB.Append("SELECT PersonID, Name ");
StrB.Append("FROM tblPerson ");
StrB.Append("ORDER BY Name ASC ");

if (!dbUtil.Open()) /* Open Database */
   {
   Str = string.Format("Failed to open database\nLastError = {0}\n{1}", dbUtil.LastError.ToString(),
      dbUtil.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

dbUtil.CommandText = StrB.ToString();

while (dbUtil.ReadRow()) /* Loop Through Results */
   {
   Person = new stPerson();
   Person.PersonID = dbUtil.ReadInt(0);
   Person.Name = dbUtil.ReadString(1);

   /* Add Company Names To ComboBoxes */
   comboPersonPerson.Items.Add(new stComboItem(Person.Name, Person));
   }

dbUtil.Close();

return(true);
}

catch (Exception ex)
   {
   if (dbUtil != null)
      dbUtil.Close();

   Str = string.Format("LoadPersonNamesSELECT() Exception\n{0}", ex.Message);
   MessageBox.Show(Str);
   return(false);
   }
}
/*******************************************************************************
Function    : SavePersonSELECT()
Description : 
Parameters  : WIDBUtil dbUtil - 
            : stPerson person - 
Returns     : bool
--------------------------------------------------------------------------------
History:
2011/05/13 WLM Created
*******************************************************************************/
bool SavePersonSELECT(WIDBUtil dbUtil, stPerson person)
{
StringBuilder StrB;
int Active;
string Str;

if (person.Active)
   Active = 1;

else
   Active = 0;

StrB = new StringBuilder();
StrB.Append("INSERT INTO tblPerson ");
StrB.Append("(Name, Active, AddressID, CompanyID, PhotoID) ");
StrB.AppendFormat("Values ('{0}', {1}, {2}, {3}, {4}) ",  person.Name, Active,
   person.Address.AddressID, person.Company.CompanyID, person.PhotoID);

try
{
if (!dbUtil.ExecuteTransaction(StrB.ToString(), out person.PersonID))
   return(false);

return(true);
}

catch (Exception ex)
   {
   Str = string.Format("Failed to Create Person\n{0}", ex.Message);
   MessageBox.Show(Str);
   return(false);
   }
}
} /* End Of Class MainForm */
} /* End Of NameSpace WIDatabaseSample */